diff -ruN vdr-2.2.0/pat.h vdr-2.3.1/pat.h
--- vdr-2.2.0/pat.h	2015-01-04 14:17:22.000000000 +0100
+++ vdr-2.3.1/pat.h	2015-01-04 14:17:22.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: pat.h 3.4 2015/01/04 13:17:22 kls Exp $
+ * $Id: pat.h 4.0 2015/01/04 13:17:22 kls Exp $
  */
 
 #ifndef __PAT_H
diff -ruN vdr-2.2.0/player.c vdr-2.3.1/player.c
--- vdr-2.2.0/player.c	2012-04-28 13:52:50.000000000 +0200
+++ vdr-2.3.1/player.c	2012-04-28 13:52:50.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: player.c 3.0 2012/04/28 11:52:50 kls Exp $
+ * $Id: player.c 4.0 2012/04/28 11:52:50 kls Exp $
  */
 
 #include "player.h"
diff -ruN vdr-2.2.0/player.h vdr-2.3.1/player.h
--- vdr-2.2.0/player.h	2013-12-25 14:25:02.000000000 +0100
+++ vdr-2.3.1/player.h	2013-12-25 14:25:02.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: player.h 3.1 2013/12/25 13:25:02 kls Exp $
+ * $Id: player.h 4.0 2013/12/25 13:25:02 kls Exp $
  */
 
 #ifndef __PLAYER_H
diff -ruN vdr-2.2.0/plugin.c vdr-2.3.1/plugin.c
--- vdr-2.2.0/plugin.c	2012-09-01 15:10:27.000000000 +0200
+++ vdr-2.3.1/plugin.c	2015-04-18 16:51:20.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: plugin.c 3.0 2012/09/01 13:10:27 kls Exp $
+ * $Id: plugin.c 4.1 2015/04/18 14:51:20 kls Exp $
  */
 
 #include "plugin.h"
@@ -318,23 +318,23 @@
 void cPluginManager::AddPlugin(const char *Args)
 {
   if (strcmp(Args, "*") == 0) {
-     cReadDir d(directory);
-     struct dirent *e;
-     while ((e = d.Next()) != NULL) {
-           if (strstr(e->d_name, LIBVDR_PREFIX) == e->d_name) {
-              char *p = strstr(e->d_name, SO_INDICATOR);
-              if (p) {
-                 *p = 0;
-                 p += strlen(SO_INDICATOR);
-                 if (strcmp(p, APIVERSION) == 0) {
-                    char *name = e->d_name + strlen(LIBVDR_PREFIX);
-                    if (strcmp(name, "*") != 0) { // let's not get into a loop!
-                       AddPlugin(e->d_name + strlen(LIBVDR_PREFIX));
-                       }
-                    }
-                 }
-              }
-           }
+     cFileNameList Files(directory);
+     for (int i = 0; i < Files.Size(); i++) {
+         char *FileName = Files.At(i);
+         if (strstr(FileName, LIBVDR_PREFIX) == FileName) {
+            char *p = strstr(FileName, SO_INDICATOR);
+            if (p) {
+               *p = 0;
+               p += strlen(SO_INDICATOR);
+               if (strcmp(p, APIVERSION) == 0) {
+                  char *name = FileName + strlen(LIBVDR_PREFIX);
+                  if (strcmp(name, "*") != 0) { // let's not get into a loop!
+                     AddPlugin(FileName + strlen(LIBVDR_PREFIX));
+                     }
+                  }
+               }
+            }
+         }
      return;
      }
   char *s = strdup(skipspace(Args));
diff -ruN vdr-2.2.0/plugin.h vdr-2.3.1/plugin.h
--- vdr-2.2.0/plugin.h	2012-09-01 15:08:54.000000000 +0200
+++ vdr-2.3.1/plugin.h	2012-09-01 15:08:54.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: plugin.h 3.0 2012/09/01 13:08:54 kls Exp $
+ * $Id: plugin.h 4.0 2012/09/01 13:08:54 kls Exp $
  */
 
 #ifndef __PLUGIN_H
diff -ruN vdr-2.2.0/positioner.c vdr-2.3.1/positioner.c
--- vdr-2.2.0/positioner.c	2015-02-14 12:54:31.000000000 +0100
+++ vdr-2.3.1/positioner.c	2015-02-14 12:54:31.000000000 +0100
@@ -8,7 +8,7 @@
  * http://www.vdr-portal.de/board17-developer/board97-vdr-core/p1154305-grundlagen-und-winkelberechnungen-f%C3%BCr-h-h-diseqc-motor-antennenanlagen
  * by Albert Danis.
  *
- * $Id: positioner.c 3.5 2015/02/14 11:54:31 kls Exp $
+ * $Id: positioner.c 4.0 2015/02/14 11:54:31 kls Exp $
  */
 
 #include "positioner.h"
diff -ruN vdr-2.2.0/positioner.h vdr-2.3.1/positioner.h
--- vdr-2.2.0/positioner.h	2013-12-28 12:15:56.000000000 +0100
+++ vdr-2.3.1/positioner.h	2013-12-28 12:15:56.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: positioner.h 3.3 2013/12/28 11:15:56 kls Exp $
+ * $Id: positioner.h 4.0 2013/12/28 11:15:56 kls Exp $
  */
 
 #ifndef __POSITIONER_H
diff -ruN vdr-2.2.0/receiver.c vdr-2.3.1/receiver.c
--- vdr-2.2.0/receiver.c	2015-01-12 15:04:31.000000000 +0100
+++ vdr-2.3.1/receiver.c	2015-01-12 15:04:31.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: receiver.c 3.3 2015/01/12 14:04:31 kls Exp $
+ * $Id: receiver.c 4.0 2015/01/12 14:04:31 kls Exp $
  */
 
 #include "receiver.h"
diff -ruN vdr-2.2.0/receiver.h vdr-2.3.1/receiver.h
--- vdr-2.2.0/receiver.h	2015-01-12 15:03:22.000000000 +0100
+++ vdr-2.3.1/receiver.h	2015-09-05 13:42:47.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: receiver.h 3.3 2015/01/12 14:03:22 kls Exp $
+ * $Id: receiver.h 4.1 2015/09/05 11:42:47 kls Exp $
  */
 
 #ifndef __RECEIVER_H
@@ -31,7 +31,7 @@
                ///< (On == true) and right after it gets detached from (On == false) a cDevice. It can be used
                ///< to do things like starting/stopping a thread.
                ///< It is guaranteed that Receive() will not be called before Activate(true).
-  virtual void Receive(uchar *Data, int Length) = 0;
+  virtual void Receive(const uchar *Data, int Length) = 0;
                ///< This function is called from the cDevice we are attached to, and
                ///< delivers one TS packet from the set of PIDs the cReceiver has requested.
                ///< The data packet must be accepted immediately, and the call must return
diff -ruN vdr-2.2.0/recorder.c vdr-2.3.1/recorder.c
--- vdr-2.2.0/recorder.c	2014-02-21 10:19:52.000000000 +0100
+++ vdr-2.3.1/recorder.c	2015-09-12 16:56:15.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recorder.c 3.3 2014/02/21 09:19:52 kls Exp $
+ * $Id: recorder.c 4.4 2015/09/12 14:56:15 kls Exp $
  */
 
 #include "recorder.h"
@@ -106,9 +106,31 @@
      Cancel(3);
 }
 
-void cRecorder::Receive(uchar *Data, int Length)
+void cRecorder::Receive(const uchar *Data, int Length)
 {
   if (Running()) {
+     static const uchar aff[TS_SIZE - 4] = { 0xB7, 0x00,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
+       0xFF, 0xFF}; // Length is always TS_SIZE!
+     if ((Data[3] & 0b00110000) == 0b00100000 && !memcmp(Data + 4, aff, sizeof(aff)))
+        return; // Adaptation Field Filler found, skipping
      int p = ringBuffer->Put(Data, Length);
      if (p != Length && Running())
         ringBuffer->ReportOverflow(Length - p);
@@ -135,7 +157,8 @@
                        if (frameDetector->FramesPerSecond() > 0 && DoubleEqual(RecordingInfo.FramesPerSecond(), DEFAULTFRAMESPERSECOND) && !DoubleEqual(RecordingInfo.FramesPerSecond(), frameDetector->FramesPerSecond())) {
                           RecordingInfo.SetFramesPerSecond(frameDetector->FramesPerSecond());
                           RecordingInfo.Write();
-                          Recordings.UpdateByName(recordingName);
+                          LOCK_RECORDINGS_WRITE;
+                          Recordings->UpdateByName(recordingName);
                           }
                        }
                     InfoWritten = true;
diff -ruN vdr-2.2.0/recorder.h vdr-2.3.1/recorder.h
--- vdr-2.2.0/recorder.h	2015-01-15 15:27:02.000000000 +0100
+++ vdr-2.3.1/recorder.h	2015-09-05 13:46:23.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recorder.h 3.1 2015/01/15 14:27:02 kls Exp $
+ * $Id: recorder.h 4.1 2015/09/05 11:46:23 kls Exp $
  */
 
 #ifndef __RECORDER_H
@@ -35,7 +35,7 @@
        ///< member of the cReceiver class) from your own destructor in order
        ///< to properly get a call to Activate(false) when your object is
        ///< destroyed.
-  virtual void Receive(uchar *Data, int Length);
+  virtual void Receive(const uchar *Data, int Length);
   virtual void Action(void);
 public:
   cRecorder(const char *FileName, const cChannel *Channel, int Priority);
